#include "pscript.ch"
#include "Fileio.ch"
#include "Appevent.ch"
#include "dcdir.ch"
#include "directry.ch"
#include "dcdialog.ch"
#include "ot4xb.ch"
#pragma Library("dcxml.lib")

FUNCTION D_PokazJPK
* Funkcja wczytuje do tablic zawartosc XML z plikow 
**********************************************************************
Local aScreen,nHandle,cBuffer
Local GetList:={},GetOptions,lOdpow
PARAMETERS cFile

IF PCOUNT()=0
   cFile:=SPACE(200)

   @ 1, 0 DCSAY 'Uwaga!' SAYSIZE 0
   @ 2, 0 DCSAY 'Program pokae zawarto utworzonego wczesniej Jednolitego Pliku Kontrolnego.' SAYSIZE 0
   @ 3, 0 DCSAY 'Wska plik z danymi do wczytania:' SAYSIZE 0
   @ 4, 0 DCGET cFile PICT "@S70" POPUP {|| cFile:=ConvToOemCP(DC_PopFile(ConvToAnsiCP(cFile),,'','Wybierz plik',{{'Pliki JPK-VAT (XML)','*.XML'}})),DC_GetRefresh(GetList)} VALID {||RIGHT(UPPER(TRIM(cPlikRob)),4)=='.XML'}
 
   DCGETOPTIONS NOMAXBUTTON NOMINBUTTON
   DCREAD GUI TO lOdpow ADDBUTTONS MODAL FIT OPTIONS GetOptions TITLE 'Import danych z JPK' EVAL {|o|SetAppWindow(o)}

   IF !lOdpow
      RETURN(.F.)
   ENDIF
ENDIF
cFile:=ALLTRIM(cFile)
IF !FExists(ConvToAnsiCP(cFile))
   DC_MsgBox(,,{'Brak wskazanego pliku!'})
   RETURN(NIL)
ENDIF
nHandle:=FOpen(ConvToAnsiCP(cFile),FO_READ)
cBuffer:=SPACE(2048)
FRead(nHandle,@cBuffer,2048)
FClose(nhandle)

DO CASE
CASE 'JPK_VAT</tns:KodFormularza'$cBuffer
   D_PokazJPKVAT(cFile)
CASE 'JPK_FA</tns:KodFormularza'$cBuffer
   D_PokazJPKFA(cFile)
CASE 'JPK_MAG</tns:KodFormularza'$cBuffer
   D_PokazJPKMAG(cFile)
CASE 'JPK_KR</tns:KodFormularza'$cBuffer
   D_PokazJPKKR(cFile)
OTHERWISE
   DC_Impl(aScreen)
   DC_Msgbox(,,{'Ten plik nie ma struktury JPK-VAT.'})
   RETURN(NIL)
ENDCASE
RETURN(NIL)


FUNCTION D_PokazJPKVAT
* Funkcja wczytuje do tablic zawartosc XML z pliku JPK-VAT
**********************************************************************
Local oJPKXML,oJPK,oNaglowek,oPodmiot,oPodmiotIdn,oaFaktura
Local aScreen,i,nFontSize,cBrowseFont
Local nPos1,nPos2,oBrowse1,oBrowse2,oTabPage1,otabPage2,oTabPage3
Local GetList:={},GetOptions,lOdpow
Local aSprzedaz:={},aZakupy:={}
Local cDataSprzedazy,cDataWystawienia,cNrDokumentu,cNazwaNabywcy,cAdresNabywcy
Local cNazwaWystawcy,cAdresWystawcy,cNrIdWystawcy,cNrfaktury,cDataWplywu
PARAMETERS cFile

cFile:=ALLTRIM(cFile)
IF !FExists(ConvToAnsiCP(cFile))
   DC_MsgBox(,,{'Brak wskazanego pliku!'})
   RETURN(NIL)
ENDIF

PRIVATE cK_10,cK_11,cK_12,cK_13,cK_14,cK_15,cK_16,cK_17,cK_18,cK_19,;
        cK_20,cK_21,cK_22,cK_23,cK_24,cK_25,cK_26,cK_27,cK_28,cK_29,;
        cK_30,cK_31,cK_32,cK_33,cK_34,cK_35,cK_36,cK_37,cK_38,;
        cK_42,cK_43,cK_44,cK_45,cK_46,cK_47,cK_48

STORE 0 TO nK_10,nK_11,nK_12,nK_13,nK_14,nK_15,nK_16,nK_17,nK_18,nK_19,;
           nK_20,nK_21,nK_22,nK_23,nK_24,nK_25,nK_26,nK_27,nK_28,nK_29,;
           nK_30,nK_31,nK_32,nK_33,nK_34,nK_35,nK_36,nK_37,nK_38,;
	   	   nK_42,nK_43,nK_44,nK_45,nK_46,nK_47,nK_48

aScreen:=dc_expl(10,1,13,79,,,,,,cSayFont,.T.)
dc_say(aScreen,1,2,'Sprawdzam plik '+cFile+SPACE(10))

IF FSize(ConvToAnsiCP(ALLTRIM(cFile)))>25000000
   DC_Impl(aScreen)
   DC_MsgBox(,,{'Plik zbyt duy, moliwy jest podgld',;
                'plikw mniejszych ni 25 MB.'})
   RETURN(NIL)
ELSEIF FSize(ConvToAnsiCP(ALLTRIM(cFile)))>2000000
   * gdy plik > 2MB to komunikat ze to moze potrwac
   dc_say(aScreen,2,2,'To moe potrwa nawet kilka minut...'+SPACE(10))
ENDIF
oJPKXML:=DC_Xml2ObjectTree(ConvToAnsiCP(cFile))
dc_say(aScreen,2,2,SPACE(80))

IF EMPTY(oJPKXML)
   DC_Impl(aScreen)
   DC_Msgbox(,,{'Ten plik nie ma struktury JPK-VAT.'})
   RETURN(NIL)
ENDIF

oJPK:=oJPKXML:findNode('tns:JPK')
oNaglowek:=oJPK:findNode('tns:Naglowek')
cDataWytworzenia:=D_XML2Oem(oNaglowek:findNode('tns:DataWytworzeniaJPK'))
cGodzWytworzenia:=SUBS(SUBS(cDataWytworzenia,12,8)+SPACE(8),1,8)
cDataWytworzenia:=SUBS(cDataWytworzenia,1,10)
cDataOd:=D_XML2Oem(oNaglowek:findNode('tns:DataOd'))
cDataDo:=D_XML2Oem(oNaglowek:findNode('tns:DataDo'))
oNaglowek:=NIL

oPodmiot:=oJPK:findNode('tns:Podmiot1')
oPodmiotIdn:=oPodmiot:findNode('tns:IdentyfikatorPodmiotu')
cNIP:=D_XML2Oem(oPodmiotIdn:findNode('etd:NIP'))
cPelnaNazwa:=SUBS(D_XML2Oem(oPodmiotIdn:findNode('etd:PelnaNazwa'))+SPACE(70),1,70)
oPodmiotIdn:=NIL
oPodmiotIdn:=NIL

oCtrl:=oJPK:findNode('tns:SprzedazCtrl')
cLiczbaSprzedaz:=D_XML2Oem(oCtrl:findNode('tns:LiczbaWierszySprzedazy'))
cPodatekNalezny:=D_XML2Oem(oCtrl:findNode('tns:PodatekNalezny'))
oCtrl:=NIL

oCtrl:=oJPK:findNode('tns:ZakupCtrl')
cLiczbaZakupow:=D_XML2Oem(oCtrl:findNode('tns:LiczbaWierszyZakupow'))
cPodatekNaliczony:=D_XML2Oem(oCtrl:findNode('tns:PodatekNaliczony'))
oCtrl:=NIL

oaFaktura:=oJPK:findNode('tns:SprzedazWiersz',.T.)
FOR i:=1 TO LEN(oaFaktura)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,2,2,'Wczytuj '+LTRIM(STR(i,4,0))+' faktur (ogem: '+LTRIM(STR(LEN(oaFaktura),4,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   cDataSprzedazy  :=D_XML2Oem(oaFaktura[i]:findNode('tns:DataSprzedazy'))
   cDataWystawienia:=D_XML2Oem(oaFaktura[i]:findNode('tns:DataWystawienia'))
   cNrDokumentu    :=D_XML2Oem(oaFaktura[i]:findNode('tns:NrDokumentu'))
   cNazwaNabywcy   :=D_XML2Oem(oaFaktura[i]:findNode('tns:NazwaNabywcy'))
   cAdresNabywcy   :=D_XML2Oem(oaFaktura[i]:findNode('tns:AdresNabywcy'))
   cK_10           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_10'))
   cK_11           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_11'))
   cK_12           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_12'))
   cK_13           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_13'))
   cK_14           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_14'))
   cK_15           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_15'))
   cK_16           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_16'))
   cK_17           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_17'))
   cK_18           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_18'))
   cK_19           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_19'))
   cK_20           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_20'))
   cK_21           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_21'))
   cK_22           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_22'))
   cK_23           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_23'))
   cK_24           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_24'))
   cK_25           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_25'))
   cK_26           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_26'))
   cK_27           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_27'))
   cK_28           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_28'))
   cK_29           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_29'))
   cK_30           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_30'))
   cK_31           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_31'))
   cK_32           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_32'))
   cK_33           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_33'))
   cK_34           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_34'))
   cK_35           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_35'))
   cK_36           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_36'))
   cK_37           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_37'))
   cK_38           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_38'))

   FOR jj:=10 TO 38
      aa:='nK_'+STR(jj,2,0)
      bb:='cK_'+STR(jj,2,0)
      &aa := &aa + VAL( &bb)
      &bb := LTRIM(TRANSFORM(VAL(&bb ),"@R 999,999,999.99"))
   NEXT
   AAdd(aSprzedaz,{LTRIM(STR(i,6,0)),cDataSprzedazy,cDataWystawienia,cNrDokumentu,cNazwaNabywcy,cAdresNabywcy,;
                   cK_10,cK_11,cK_12,cK_13,cK_14,cK_15,cK_16,cK_17,cK_18,cK_19,;
                   cK_20,cK_21,cK_22,cK_23,cK_24,cK_25,cK_26,cK_27,cK_28,cK_29,;
                   cK_30,cK_31,cK_32,cK_33,cK_34,cK_35,cK_36,cK_37,cK_38})
NEXT
oaFaktura:=NIL
FOR jj:=10 TO 38
   aa:='nK_'+STR(jj,2,0)
   bb:='cK_'+STR(jj,2,0)
   &bb := LTRIM(TRANSFORM(&aa ,"@R 999,999,999.99"))
NEXT
AAdd(aSprzedaz,{'Razem','','','','','',;
                cK_10,cK_11,cK_12,cK_13,cK_14,cK_15,cK_16,cK_17,cK_18,cK_19,;
                cK_20,cK_21,cK_22,cK_23,cK_24,cK_25,cK_26,cK_27,cK_28,cK_29,;
                cK_30,cK_31,cK_32,cK_33,cK_34,cK_35,cK_36,cK_37,cK_38})

oaFaktura:=oJPK:findNode('tns:ZakupWiersz',.T.)
FOR i:=1 TO LEN(oaFaktura)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,2,2,'Wczytuj '+LTRIM(STR(i,4,0))+' faktur (ogem: '+LTRIM(STR(LEN(oaFaktura),4,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   cNazwaWystawcy  :=D_XML2Oem(oaFaktura[i]:findNode('tns:NazwaWystawcy'))
   cAdresWystawcy  :=D_XML2Oem(oaFaktura[i]:findNode('tns:AdresWystawcy'))
   cNrIdWystawcy   :=D_XML2Oem(oaFaktura[i]:findNode('tns:NrIdWystawcy'))
   cNrFaktury      :=D_XML2Oem(oaFaktura[i]:findNode('tns:NrFaktury'))
   cDataWplywu     :=D_XML2Oem(oaFaktura[i]:findNode('tns:DataWplywuFaktury'))
   cK_42           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_42'))
   cK_43           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_43'))
   cK_44           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_44'))
   cK_45           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_45'))
   cK_46           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_46'))
   cK_47           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_47'))
   cK_48           :=D_XML2Oem(oaFaktura[i]:findNode('tns:K_48'))

   FOR jj:=42 TO 48
      aa:='nK_'+STR(jj,2,0)
      bb:='cK_'+STR(jj,2,0)
      &aa := &aa + VAL( &bb)
      &bb := LTRIM(TRANSFORM(VAL(&bb ),"@R 999,999,999.99"))
   NEXT
   AAdd(aZakupy,{LTRIM(STR(i,6,0)),cNazwaWystawcy,cAdresWystawcy,cNrIdWystawcy,cNrFaktury,cDataWplywu,;
                 cK_42,cK_43,cK_44,cK_45,cK_46,cK_47,cK_48})
NEXT
oaFaktura:=NIL
oJPK:=NIL
FOR jj:=42 TO 48
   aa:='nK_'+STR(jj,2,0)
   bb:='cK_'+STR(jj,2,0)
   &bb := LTRIM(TRANSFORM(&aa ,"@R 999,999,999.99"))
NEXT
AAdd(aZakupy,{'Razem','','','','','',cK_42,cK_43,cK_44,cK_45,cK_46,cK_47,cK_48})
DC_Impl(aScreen)
nFontSize:=VAL(SUBS(cSayFont,1,AT('.',cSayFont)-1))-1
nFontSize:=Min(nFontSize,12)
cBrowseFont:=LTRIM(STR(nFontSize,2,0))+SUBS(cSayFont,AT('.',cSayFont))

@ 0, 0 DCTABPAGE oTabPage1 CAPTION 'Dane podstawowe' SIZE 87,24 TABHEIGHT 36 TABWIDTH 16
DCSETPARENT TO oTabPage1
@ 2, 2 DCSAY 'Jednostka:' SAYSIZE 0
@ 3, 2 DCSAY 'NIP:' SAYSIZE 0
@ 4, 2 DCSAY 'Dane za okres od:' SAYSIZE 0
@ 5, 2 DCSAY 'do:'
@ 6, 2 DCSAY 'Data wytworzenia:' SAYSIZE 0
@ 7, 2 DCSAY 'Godzina wytworzenia:' SAYSIZE 0
@ 9, 2 DCSAY 'Sprzeda - pozycji:' SAYSIZE 0
@10, 2 DCSAY 'Podatek naleny:' SAYSIZE 0
@11, 2 DCSAY 'Zakupy - pozycji:' SAYSIZE 0
@12, 2 DCSAY 'Podatek naliczony:' SAYSIZE 0

@ 2,19 DCGET cPelnaNazwa EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 3,19 DCGET cNIP EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 4,19 DCGET cDataOd EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 5,19 DCGET cDataDo EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 6,19 DCGET cDataWytworzenia EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 7,19 DCGET cGodzWytworzenia EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 9,19 DCGET cLiczbaSprzedaz EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@10,19 DCGET cPodatekNalezny EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@11,19 DCGET cLiczbaZakupow EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@12,19 DCGET cPodatekNaliczony EDITPROTECT {||.T.} GETCOLOR {||SayColor}

DCSETPARENT TO

@ 0, 0 DCTABPAGE oTabPage2 CAPTION 'Sprzeda' SIZE 87,24 RELATIVE oTabPage1
DCSETPARENT TO oTabPage2
nPos1:=1
@ 2,1 DCBROWSE oBrowse1 DATA aSprzedaz POINTER nPos1 SIZE 85,21 CURSORMODE XBPBRW_CURSOR_ROW PRESENTATION DC_BrowPres() HEADLINES 5 FONT cBrowseFont
   DCBROWSECOL ELEMENT  1 HEADER 'Lp.' PARENT oBrowse1 WIDTH 4 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT  2 HEADER 'Data;sprzeday' PARENT oBrowse1 WIDTH 7 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT  3 HEADER 'Data;wystawienia' PARENT oBrowse1 WIDTH 7 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT  4 HEADER 'Nr dokumentu' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT  5 HEADER 'Nabywca' PARENT oBrowse1 WIDTH 12 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT  6 HEADER 'Adres nabywcy' PARENT oBrowse1 WIDTH 12 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT  7 HEADER 'Sprzeda;zwolniona' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT  8 HEADER 'Dostawa;poza kraj' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT  9 HEADER 'Dostawa;poza kraj;w tym;art.100' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 10 HEADER 'Sprzeda;VAT 0%' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 11 HEADER 'Sprzeda;VAT 0%;w tym;art.129' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 12 HEADER 'Sprzeda;5%;netto' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 13 HEADER 'Sprzeda;5%;VAT' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 14 HEADER 'Sprzeda;8%;netto' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 15 HEADER 'Sprzeda;8%;VAT' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 16 HEADER 'Sprzeda;23%;netto' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 17 HEADER 'Sprzeda;23%;VAT' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 18 HEADER 'WDT' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 19 HEADER 'Eksport' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 20 HEADER 'WNT;netto' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 21 HEADER 'WNT;VAT' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 22 HEADER 'Import;art.33a;netto' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 23 HEADER 'Import;art.33a;VAT' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 24 HEADER 'Import;z wyczeniem;art 28b;netto' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 25 HEADER 'Import;z wyczeniem;art 28b;VAT' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 26 HEADER 'Import;zgodnie z;art 28b;netto' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 27 HEADER 'Import;zgodnie z;art 28b;VAT' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 28 HEADER 'Odwrotne;obcienie;(dostawca)' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 29 HEADER 'Odwrotne;obcienie;pkt 5;(nabywca);netto' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 30 HEADER 'Odwrotne;obcienie;pkt 5;(nabywca);VAT' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 31 HEADER 'Odwrotne;obcienie;pkt 7,8;(nabywca);netto' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 32 HEADER 'Odwrotne;obcienie;pkt 7,8;(nabywca);VAT' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 33 HEADER 'Podatek od;spisu z;natury' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 34 HEADER 'Zwrot;kwoty za;zakup kas;fiskalnych' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 35 HEADER 'Podatek;od nabytych;rodkw;transportu' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
DCSETPARENT TO

@ 0, 0 DCTABPAGE oTabPage3 CAPTION 'Zakupy' SIZE 87,24 RELATIVE oTabPage2
DCSETPARENT TO oTabPage3
nPos2:=1

@ 2,0 DCBROWSE oBrowse2 DATA aZakupy POINTER nPos2 SIZE 85,21 CURSORMODE XBPBRW_CURSOR_ROW PRESENTATION DC_BrowPres() HEADLINES 4 FONT cBrowseFont
   DCBROWSECOL ELEMENT  1 HEADER 'Lp.' PARENT oBrowse2 WIDTH 4 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT  6 HEADER 'Data wpywu' PARENT oBrowse2 WIDTH 7 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT  5 HEADER 'Nr dokumentu' PARENT oBrowse2 WIDTH 8 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT  2 HEADER 'Sprzedawca' PARENT oBrowse2 WIDTH 12 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT  3 HEADER 'Adres sprzedawcy' PARENT oBrowse2 WIDTH 12 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT  7 HEADER 'Nabycie;rodkw;trwaych;netto' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT  8 HEADER 'Nabycie;rodkw;trwaych;VAT' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT  9 HEADER 'Nabycie;pozostae;netto' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 10 HEADER 'Nabycie;pozostae;VAT' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 11 HEADER 'Korekta;podatku od;nabycia;r.trwaych' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 11 HEADER 'Korekta;podatku od;pozostaych;naby' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 12 HEADER 'Korekta;podatku;art. 89b' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_RIGHT
DCSETPARENT TO

DCGETOPTIONS NOMAXBUTTON NOMINBUTTON
DCREAD GUI MODAL FIT BUTTONS DCGUI_BUTTON_OK OPTIONS GetOptions TITLE 'Zawarto pliku JPK-VAT '+cFile EVAL {|o| SetAppWindow(o)}

RETURN(NIL)


FUNCTION D_PokazJPKFA
* Funkcja wczytuje do tablic zawartosc XML z pliku JPK-FA
**********************************************************************
Local oJPKXML,oJPK,oNaglowek,oPodmiot,oPodmiotIdn,oaFaktura
Local aScreen,i,nFontSize,cBrowseFont
Local nPos1,oBrowse1,oTabPage1,otabPage2
Local GetList:={},GetOptions,lOdpow
Local aFaktury:={}
PARAMETERS cFile

PRIVATE aFakturyW:={}

cFile:=ALLTRIM(cFile)

aScreen:=dc_expl(10,1,13,79,,,,,,cSayFont,.T.)
dc_say(aScreen,1,2,'Sprawdzam plik '+cFile+SPACE(10))
IF FSize(ConvToAnsiCP(ALLTRIM(cFile)))>25000000
   DC_Impl(aScreen)
   DC_MsgBox(,,{'Plik zbyt duy, moliwy jest podgld',;
                'plikw mniejszych ni 25 MB.'})
   RETURN(NIL)
ELSEIF FSize(ConvToAnsiCP(ALLTRIM(cFile)))>2000000
   * gdy plik > 2MB to komunikat ze to moze potrwac
   dc_say(aScreen,2,2,'To moe potrwa nawet kilka minut...'+SPACE(10))
ENDIF
oJPKXML:=DC_Xml2ObjectTree(ConvToAnsiCP(cFile))
dc_say(aScreen,2,2,SPACE(10))
IF EMPTY(oJPKXML)
   DC_Impl(aScreen)
   DC_Msgbox(,,{'Ten plik nie ma struktury JPK-FA.'})
   RETURN(NIL)
ENDIF

oJPK:=oJPKXML:findNode('tns:JPK')
oNaglowek:=oJPK:findNode('tns:Naglowek')
cDataWytworzenia:=D_XML2Oem(oNaglowek:findNode('tns:DataWytworzeniaJPK'))
cGodzWytworzenia:=SUBS(SUBS(cDataWytworzenia,12,8)+SPACE(8),1,8)
cDataWytworzenia:=SUBS(cDataWytworzenia,1,10)
cDataOd:=D_XML2Oem(oNaglowek:findNode('tns:DataOd'))
cDataDo:=D_XML2Oem(oNaglowek:findNode('tns:DataDo'))
oNaglowek:=NIL

oPodmiot:=oJPK:findNode('tns:Podmiot1')
oPodmiotIdn:=oPodmiot:findNode('tns:IdentyfikatorPodmiotu')
cNIP:=D_XML2Oem(oPodmiotIdn:findNode('etd:NIP'))
cPelnaNazwa:=SUBS(D_XML2Oem(oPodmiotIdn:findNode('etd:PelnaNazwa'))+SPACE(70),1,70)
oPodmiot:=NIL

oCtrl:=oJPK:findNode('tns:FakturaCtrl')
cLiczbaFaktur:=D_XML2Oem(oCtrl:findNode('tns:LiczbaFaktur'))
cWartoscFaktur:=D_XML2Oem(oCtrl:findNode('tns:WartoscFaktur'))
oCtrl:=NIL

oCtrl:=oJPK:findNode('tns:FakturaWierszCtrl')
cLiczbaWFaktur:=D_XML2Oem(oCtrl:findNode('tns:LiczbaWierszyFaktur'))
cWartoscWFaktur:=D_XML2Oem(oCtrl:findNode('tns:WartoscWierszyFaktur'))
oCtrl:=NIL

oaFaktura:=oJPK:findNode('tns:Faktura',.T.)
IF LEN(oaFaktura)=0
   DC_Impl(aScreen)
   DC_Msgbox(,,{'We wskazanym pliku brak zapisanych faktur.'})
   RETURN(.F.)
ENDIF
aFaktury:={}
FOR i:=1 TO LEN(oaFaktura)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,1,2,'Wczytuj '+LTRIM(STR(i,4,0))+' faktur (ogem: '+LTRIM(STR(LEN(oaFaktura),4,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   cP_1   :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_1'))
   cP_2A  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_2A'))
   cP_3A  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_3A'))
   cP_3B  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_3B'))
   cP_3C  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_3C'))
   cP_3D  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_3D'))
   cP_4A  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_4A'))
   cP_4B  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_4B'))
   cP_5A  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_5A'))
   cP_5B  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_5B'))
   cP_6   :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_6'))
   cP_13_1:=D_XML2OemF(oaFaktura[i]:findNode('tns:P_13_1'))
   cP_14_1:=D_XML2OemF(oaFaktura[i]:findNode('tns:P_14_1'))
   cP_13_2:=D_XML2OemF(oaFaktura[i]:findNode('tns:P_13_2'))
   cP_14_2:=D_XML2OemF(oaFaktura[i]:findNode('tns:P_14_2'))
   cP_13_3:=D_XML2OemF(oaFaktura[i]:findNode('tns:P_13_3'))
   cP_14_3:=D_XML2OemF(oaFaktura[i]:findNode('tns:P_14_3'))
   cP_13_4:=D_XML2OemF(oaFaktura[i]:findNode('tns:P_13_4'))
   cP_14_4:=D_XML2OemF(oaFaktura[i]:findNode('tns:P_14_4'))
   cP_13_5:=D_XML2OemF(oaFaktura[i]:findNode('tns:P_13_5'))
   cP_14_5:=D_XML2OemF(oaFaktura[i]:findNode('tns:P_14_5'))
   cP_13_6:=D_XML2OemF(oaFaktura[i]:findNode('tns:P_13_6'))
   cP_13_7:=D_XML2OemF(oaFaktura[i]:findNode('tns:P_13_7'))
   cP_15  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_15'))
   cP_16  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_16'))
   cP_17  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_17'))
   cP_18  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_18'))
   cP_19  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_19'))
   cP_19A :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_19A'))
   cP_19B :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_19B'))
   cP_19C :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_19C'))
   cP_20  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_20'))
   cP_20A :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_20A'))
   cP_20B :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_20B'))
   cP_21  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_21'))
   cP_21A :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_21A'))
   cP_21B :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_21B'))
   cP_21C :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_21C'))
   cP_22A :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_22A'))
   cP_22B :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_22B'))
   cP_22C :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_22C'))
   cP_23  :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_23'))
   cP_106E_2 :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_106E_2'))
   cP_106E_3 :=D_XML2OemF(oaFaktura[i]:findNode('tns:P_106E_3'))
   cP_106E_3A:=D_XML2OemF(oaFaktura[i]:findNode('tns:P_106E_3A'))
   cP_Rodzaj :=D_XML2OemF(oaFaktura[i]:findNode('tns:RodzajFaktury'))
   cP_PrzKor :=D_XML2OemF(oaFaktura[i]:findNode('tns:PrzyczynaKorekty'))
   cP_NrFakor:=D_XML2OemF(oaFaktura[i]:findNode('tns:NaFaKorygowanej'))
   cP_OkresK :=D_XML2OemF(oaFaktura[i]:findNode('tns:OkresFaKorygowanej'))
   cP_Zaplata:=D_XML2OemF(oaFaktura[i]:findNode('tns:ZALZaplata'))
   cP_Podatek:=D_XML2OemF(oaFaktura[i]:findNode('tns:ZALPodatek'))

* Pierwszy element to nr kolejny
   AAdd(aFaktury,{STR(i,5,0),cP_1,cP_2A,cP_3A,cP_3B,cP_3C,cP_3D,AllTrim(cP_4A+' '+cP_4B),;
                  AllTrim(cP_5A+' '+cP_5B),cP_6,cP_13_1,cP_14_1,cP_13_2,cP_14_2,cP_13_3,cP_14_3,;
				  cP_13_4,cP_14_4,cP_13_5,cP_14_5,cP_13_6,cP_13_7,cP_15,cP_16,cP_17,cP_18,cP_19,;
                  cP_19A,cP_19B,cP_19C,cP_20,cP_20A,cP_20B,cP_21,cP_21A,cP_21B,cP_21C,cP_22A,;
				  cP_22B,cP_22C,cP_23,cP_106E_2,cP_106E_3,cP_106E_3A,cP_Rodzaj,cP_PrzKor,cP_NrFaKor,;
				  cP_OkresK,cP_Zaplata,cP_Podatek})
NEXT
oaFaktura:=NIL
* Specyfikacja
oaFakturaW:=oJPK:findNode('tns:FakturaWiersz',.T.)
aFakturyW:={}
FOR i:=1 TO LEN(oaFakturaW)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,1,2,'Wczytuj '+LTRIM(STR(i,4,0))+' wiersz faktury (ogem: '+LTRIM(STR(LEN(oaFakturaW),4,0))+') - prosz czeka!'+SPACE(5))
   ENDIF
   cP_2B  :=D_XML2OemF(oaFakturaW[i]:findNode('tns:P_2B'))
   cP_7   :=D_XML2OemF(oaFakturaW[i]:findNode('tns:P_7'))
   cP_8A  :=D_XML2OemF(oaFakturaW[i]:findNode('tns:P_8A'))
   cP_8B  :=D_XML2OemF(oaFakturaW[i]:findNode('tns:P_8B'))
   cP_9A  :=D_XML2OemF(oaFakturaW[i]:findNode('tns:P_9A'))
   cP_9B  :=D_XML2OemF(oaFakturaW[i]:findNode('tns:P_9B'))
   cP_10  :=D_XML2OemF(oaFakturaW[i]:findNode('tns:P_10'))
   cP_11  :=D_XML2OemF(oaFakturaW[i]:findNode('tns:P_11'))
   cP_11A :=D_XML2OemF(oaFakturaW[i]:findNode('tns:P_11A'))
   cP_12  :=D_XML2OemF(oaFakturaW[i]:findNode('tns:P_12'))

   AAdd(aFakturyW,{cP_2B,cP_7,cP_8A,cP_8B,cP_9A,cP_9B,cP_10,cP_11,cP_11A,cP_12})
NEXT
oaFakturaW:=NIL
oJPK:=NIL
ASort(aFakturyW,,,{|aX,aY| aX[1]<aY[1]})

DC_Impl(aScreen)
nFontSize:=VAL(SUBS(cSayFont,1,AT('.',cSayFont)-1))-1
nFontSize:=Min(nFontSize,12)
cBrowseFont:=LTRIM(STR(nFontSize,2,0))+SUBS(cSayFont,AT('.',cSayFont))

@ 0, 0 DCTABPAGE oTabPage1 CAPTION 'Dane podstawowe' SIZE 87,24 TABHEIGHT 36 TABWIDTH 16
DCSETPARENT TO oTabPage1
@ 2, 2 DCSAY 'Jednostka:' SAYSIZE 0
@ 3, 2 DCSAY 'NIP:' SAYSIZE 0
@ 4, 2 DCSAY 'Dane za okres od:' SAYSIZE 0
@ 5, 2 DCSAY 'do:'
@ 6, 2 DCSAY 'Data wytworzenia:' SAYSIZE 0
@ 7, 2 DCSAY 'Godzina wytworzenia:' SAYSIZE 0
@ 9, 2 DCSAY 'Liczba faktur:' SAYSIZE 0
@10, 2 DCSAY 'Warto faktur:' SAYSIZE 0
@11, 2 DCSAY 'Liczba pozycji na fakturach:' SAYSIZE 0
@12, 2 DCSAY 'Warto pozycji na fakturach:' SAYSIZE 0

@ 2,12 DCGET cPelnaNazwa EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 3,27 DCGET cNIP EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 4,27 DCGET cDataOd EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 5,27 DCGET cDataDo EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 6,27 DCGET cDataWytworzenia EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 7,27 DCGET cGodzWytworzenia EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 9,27 DCGET cLiczbaFaktur EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@10,27 DCGET cWartoscFaktur EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@11,27 DCGET cLiczbaWFaktur EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@12,27 DCGET cWartoscWFaktur EDITPROTECT {||.T.} GETCOLOR {||SayColor}

DCSETPARENT TO

@ 0, 0 DCTABPAGE oTabPage2 CAPTION 'Faktury' SIZE 87,24 RELATIVE oTabPage1
DCSETPARENT TO oTabPage2
@ 1.2,20 DCPUSHBUTTON CAPTION 'Szczegy faktury' SIZE 15,1.5 TOOLTIP 'Poka wszystkie pozycje faktury' ACTION {||D_PokazJPKFASzczegoly(aFaktury[nPos1,3]),SetAppFocus(oBrowse1)}

nPos1:=1
@ 3,1 DCBROWSE oBrowse1 DATA aFaktury POINTER nPos1 SIZE 85,21 CURSORMODE XBPBRW_CURSOR_ROW PRESENTATION DC_BrowPres() HEADLINES 5 FONT cBrowseFont
   DCBROWSECOL ELEMENT  1 HEADER 'Lp.' PARENT oBrowse1 WIDTH 4 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT  2 HEADER 'Data;wystawienia' PARENT oBrowse1 WIDTH 7 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT  3 HEADER 'Nr faktury' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT  4 HEADER 'Odbiorca' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT  5 HEADER 'Adres;odbiorcy' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT  6 HEADER 'Sprzedawca' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT  7 HEADER 'Adres;sprzedawcy' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT  8 HEADER 'NIP;sprzedawcy' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT  9 HEADER 'NIP;odbiorcy' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 10 HEADER 'Data;sprzeday' PARENT oBrowse1 WIDTH 7 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 11 HEADER 'Sprzeda;23 %;netto' PARENT oBrowse1 WIDTH 5.5 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 12 HEADER 'Sprzeda;23 %;VAT' PARENT oBrowse1 WIDTH 5.5 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 13 HEADER 'Sprzeda;8 %;netto' PARENT oBrowse1 WIDTH 5.5 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 14 HEADER 'Sprzeda;8 %;VAT' PARENT oBrowse1 WIDTH 5.5 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 15 HEADER 'Sprzeda;5 %;netto' PARENT oBrowse1 WIDTH 5.5 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 16 HEADER 'Sprzeda;5 %;VAT' PARENT oBrowse1 WIDTH 5.5 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 17 HEADER 'Sprzeda;rezerwa 1;netto;(odwrotne;obcienie)' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 18 HEADER 'Sprzeda;rezerwa 1;VAT;(odwrotne;obcienie)' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 19 HEADER 'Sprzeda;rezerwa 2;netto;(nie;podlega)' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 20 HEADER 'Sprzeda;rezerwa 2;VAT;(nie;podlega)' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 21 HEADER 'Sprzeda;0 %;netto' PARENT oBrowse1 WIDTH 5.5 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 22 HEADER 'Sprzeda;zwolniona;z VAT' PARENT oBrowse1 WIDTH 5.5 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 23 HEADER 'Naleno;ogem' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 24 HEADER 'Metoda;kasowa' PARENT oBrowse1 WIDTH 5 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 25 HEADER 'Samo-;faktu-;rowanie' PARENT oBrowse1 WIDTH 5 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 26 HEADER 'Odwrotne;obcienie' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 27 HEADER 'Zwolnione;art.43 lub;art.113 lub;art.82' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 28 HEADER 'Podstawa;zwolnienia' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 29 HEADER 'Podstawa;zwolnienia;wg dyrektywy;2006/112/WE' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 30 HEADER 'Podstawa;zwolnienia;inna' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 31 HEADER 'Czy;art.106c' PARENT oBrowse1 WIDTH 5 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 32 HEADER 'Komornik;lub organ;egzekucyjny' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 33 HEADER 'Adres;komornika;lub organu;egzekucyjnego' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 34 HEADER 'Faktura;wystawiona;przez;przedstaw.' PARENT oBrowse1 WIDTH 7 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 35 HEADER 'Nazwa;przedstawiciela' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 36 HEADER 'Adres;przedstawiciela' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 37 HEADER 'NIP;przedstawiciela' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 38 HEADER 'Data;dopuszczenia;rodka;transportu' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 39 HEADER 'Przebieg;rodka;transportu' PARENT oBrowse1 WIDTH 7 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 40 HEADER 'Liczba;godzin;rodka;transportu' PARENT oBrowse1 WIDTH 7 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 41 HEADER 'Czy;drugi w;transakcji;trjstronnej' PARENT oBrowse1 WIDTH 7 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 42 HEADER 'Czy;mara;dla biur;podry' PARENT oBrowse1 WIDTH 5 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 43 HEADER 'Czy;mara;dla;uywanych' PARENT oBrowse1 WIDTH 5 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 44 HEADER 'Rodzaj;uywanych' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 45 HEADER 'Rodzaj;faktury' PARENT oBrowse1 WIDTH 5 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 46 HEADER 'Przyczyna;korekty' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 47 HEADER 'Nr faktury;korygowanej' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 48 HEADER 'Okres;faktury;korygowanej' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 49 HEADER 'Faktura;zaliczkowa;zapata' PARENT oBrowse1 WIDTH 7 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 50 HEADER 'Faktura;zaliczkowa;podatek' PARENT oBrowse1 WIDTH 7 ALIGN XBPALIGN_RIGHT
DCSETPARENT TO

DCGETOPTIONS NOMAXBUTTON NOMINBUTTON
DCREAD GUI MODAL FIT BUTTONS DCGUI_BUTTON_OK OPTIONS GetOptions TITLE 'Zawarto pliku JPK-FA '+cFile EVAL {|o| SetAppWindow(o)}

aFakturyW:={}
RETURN(NIL)


FUNCTION D_PokazJPKFASzczegoly(cNrFaktury)
* Wyswietlenie szczegolow faktury
**********************************
Local GetList:={},GetOptions,aWykaz:={},nPos,oBrowse
nPos:=AScan(aFakturyW,{|a| cNrFaktury==a[1]})
IF nPos=0
   DC_MsgBox(,,{'Brak specyfikacji dla faktury!'},,,2)
   RETURN(NIL)
ENDIF
DO WHILE nPos<=LEN(aFakturyW)
   IF aFakturyW[nPos,1]#cNrFaktury
      EXIT
   ENDIF
   AAdd(aWykaz,aFakturyW[nPos])
   nPos:=nPos+1
ENDDO
nPos:=1
@3,0 DCBROWSE oBrowse DATA aWykaz POINTER nPos SIZE 88,15 FIT CURSORMODE XBPBRW_CURSOR_ROW PRESENTATION DC_BrowPres() ITEMSELECTED {||aFaktury[nPos,2]:=!aFaktury[nPos,2],nIleZazn:=nIleZazn+IF(aFaktury[nPos,2],1,-1),oBrowse:refreshCurrent(),oBrowse:down(),oBrowse:refreshCurrent(),DC_GetRefresh(GetList)} HEADLINES 3 FONT cBrowseFont
   DCBROWSECOL ELEMENT 2  HEADER 'Nazwa' PARENT oBrowse WIDTH 25 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 4  HEADER 'Ilo' PARENT oBrowse WIDTH 4.5 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 3  HEADER 'JM' PARENT oBrowse WIDTH 4  ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 5  HEADER 'Cena;jednostkowa;netto' PARENT oBrowse WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 6  HEADER 'Cena;jednostkowa;brutto' PARENT oBrowse WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 7  HEADER 'Kwota;rabatu' PARENT oBrowse WIDTH 5 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 8  HEADER 'Warto;netto' PARENT oBrowse WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 9  HEADER 'Warto;brutto' PARENT oBrowse WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 10 HEADER 'Stawka;VAT' PARENT oBrowse WIDTH 4 ALIGN XBPALIGN_HCENTER

DCGETOPTIONS NOMAXBUTTON NOMINBUTTON
DCREAD GUI MODAL FIT BUTTONS DCGUI_BUTTON_OK OPTIONS GetOptions TITLE 'Specyfikacja faktury '+cNrFaktury EVAL {|o|SetAppFocus(oBrowse),SetAppWindow(o)}
RETURN(NIL)


FUNCTION D_PokazJPKMAG
* Funkcja wczytuje do tablic zawartosc XML z pliku JPK-MAG
**********************************************************************
Local oJPKXML,oJPK,oNaglowek,oPodmiot,oPodmiotIdn,oaFaktura
Local aScreen,i,nFontSize,cBrowseFont
Local nPos1,nPos2,nPos3,nPos4,oBrowse1,oBrowse2,oBrowse3,oBrowse4,oTabPage1,otabPage2,oTabPage3,oTabPage4,oTabPage5
Local GetList:={},GetOptions,lOdpow
Local aPZ:={},aWZ:={},aRW:={},aMM:={}
Local cLiczbaPZ:='0',cWartoscPZ:='0.00',cLiczbaWZ:='0',cWartoscWZ:='0.00',;
      cLiczbaRW:='0',cWartoscRW:='0.00',cLiczbaMM:='0',cWartoscMM:='0.00'
PARAMETERS cFile

PRIVATE aPZW:={},aWZW:={},aRWW:={},aMMW:={}

cFile:=ALLTRIM(cFile)

aScreen:=dc_expl(10,1,13,79,,,,,,cSayFont,.T.)
dc_say(aScreen,1,2,'Sprawdzam plik '+cFile+SPACE(10))
IF FSize(ConvToAnsiCP(ALLTRIM(cFile)))>25000000
   DC_Impl(aScreen)
   DC_MsgBox(,,{'Plik zbyt duy, moliwy jest podgld',;
                'plikw mniejszych ni 25 MB.'})
   RETURN(NIL)
ELSEIF FSize(ConvToAnsiCP(ALLTRIM(cFile)))>2000000
   * gdy plik > 2MB to komunikat ze to moze potrwac
   dc_say(aScreen,2,2,'To moe potrwa nawet kilka minut...'+SPACE(10))
ENDIF
oJPKXML:=DC_Xml2ObjectTree(ConvToAnsiCP(cFile))
dc_say(aScreen,2,2,SPACE(10))
IF EMPTY(oJPKXML)
   DC_Impl(aScreen)
   DC_Msgbox(,,{'Ten plik nie ma struktury JPK-MAG.'})
   RETURN(NIL)
ENDIF

oJPK:=oJPKXML:findNode('tns:JPK')
oNaglowek:=oJPK:findNode('tns:Naglowek')
cDataWytworzenia:=D_XML2Oem(oNaglowek:findNode('tns:DataWytworzeniaJPK'))
cGodzWytworzenia:=SUBS(SUBS(cDataWytworzenia,12,8)+SPACE(8),1,8)
cDataWytworzenia:=SUBS(cDataWytworzenia,1,10)
cDataOd:=D_XML2Oem(oNaglowek:findNode('tns:DataOd'))
cDataDo:=D_XML2Oem(oNaglowek:findNode('tns:DataDo'))
oNaglowek:=NIL

oPodmiot:=oJPK:findNode('tns:Podmiot1')
oPodmiotIdn:=oPodmiot:findNode('tns:IdentyfikatorPodmiotu')
cNIP:=D_XML2Oem(oPodmiotIdn:findNode('etd:NIP'))
cPelnaNazwa:=SUBS(D_XML2Oem(oPodmiotIdn:findNode('etd:PelnaNazwa'))+SPACE(70),1,70)
cMagazyn:=D_XML2Oem(oJPK:findNode('tns:Magazyn'))
oPodmiot:=NIL

oaFaktura:=oJPK:findNode('tns:PZ')
IF ValType(oaFaktura)='O'
 oaPZ:=oaFaktura:findNode('tns:PZWartosc',.T.)
 FOR i:=1 TO LEN(oaPZ)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,1,2,'Wczytuj '+LTRIM(STR(i,5,0))+' PZ (ogem: '+LTRIM(STR(LEN(oaPZ),5,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   c_1   :=D_XML2OemF(oaPZ[i]:findNode('tns:NumerPZ'))
   c_2   :=D_XML2OemF(oaPZ[i]:findNode('tns:DataPZ'))
   c_3   :=D_XML2OemF(oaPZ[i]:findNode('tns:WartoscPZ'))
   c_4   :=D_XML2OemF(oaPZ[i]:findNode('tns:DataOtrzymaniaPZ'))
   c_5   :=D_XML2OemF(oaPZ[i]:findNode('tns:Dostawca'))
   c_6   :=D_XML2OemF(oaPZ[i]:findNode('tns:NumerFaPZ'))
   c_7   :=D_XML2OemF(oaPZ[i]:findNode('tns:DataFaPZ'))

   AAdd(aPZ,{STR(i,5,0),c_1,c_2,c_3,c_4,c_5,c_6,c_7})
 NEXT
 oaPZ:=NIL
 oaPZW:=oaFaktura:findNode('tns:PZWiersz',.T.)
 FOR i:=1 TO LEN(oaPZW)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,1,2,'Wczytuj '+LTRIM(STR(i,5,0))+' PZ (ogem: '+LTRIM(STR(LEN(oaPZW),5,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   c_1   :=D_XML2OemF(oaPZW[i]:findNode('tns:Numer2PZ'))
   c_2   :=D_XML2OemF(oaPZW[i]:findNode('tns:KodTowaruPZ'))
   c_3   :=D_XML2OemF(oaPZW[i]:findNode('tns:NazwaTowaruPZ'))
   c_4   :=D_XML2OemF(oaPZW[i]:findNode('tns:IloscPrzyjetaPZ'))
   c_5   :=D_XML2OemF(oaPZW[i]:findNode('tns:JednostkaMiaryPZ'))
   c_6   :=D_XML2OemF(oaPZW[i]:findNode('tns:CenaJednPZ'))
   c_7   :=D_XML2OemF(oaPZW[i]:findNode('tns:WartoscPozycjiPZ'))

   AAdd(aPZW,{c_1,c_2,c_3,c_4,c_5,c_6,c_7})
 NEXT
 oaPZ:=NIL
 oCtrl:=oaFaktura:findNode('tns:PZCtrl')
 cLiczbaPZ :=D_XML2Oem(oCtrl:findNode('tns:LiczbaPZ'))
 cWartoscPZ:=D_XML2Oem(oCtrl:findNode('tns:SumaPZ'))
 ASort(aPZW,,,{|aX,aY| aX[1]<aY[1]})
 oCtrl:=NIL
ENDIF
oaFaktura:=oJPK:findNode('tns:WZ')
IF ValType(oaFaktura)='O'
 oaWZ:=oaFaktura:findNode('tns:WZWartosc',.T.)
 FOR i:=1 TO LEN(oaWZ)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,1,2,'Wczytuj '+LTRIM(STR(i,5,0))+' WZ (ogem: '+LTRIM(STR(LEN(oaWZ),5,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   c_1   :=D_XML2OemF(oaWZ[i]:findNode('tns:NumerWZ'))
   c_2   :=D_XML2OemF(oaWZ[i]:findNode('tns:DataWZ'))
   c_3   :=D_XML2OemF(oaWZ[i]:findNode('tns:WartoscWZ'))
   c_4   :=D_XML2OemF(oaWZ[i]:findNode('tns:DataWydaniaWZ'))
   c_5   :=D_XML2OemF(oaWZ[i]:findNode('tns:OdbiorcaWZ'))
   c_6   :=D_XML2OemF(oaWZ[i]:findNode('tns:NumerFaWZ'))
   c_7   :=D_XML2OemF(oaWZ[i]:findNode('tns:DataFaWZ'))

   AAdd(aWZ,{STR(i,5,0),c_1,c_2,c_3,c_4,c_5,c_6,c_7})
 NEXT
 oaWZ:=NIL
 oaWZW:=oaFaktura:findNode('tns:WZWiersz',.T.)
 FOR i:=1 TO LEN(oaWZW)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,1,2,'Wczytuj '+LTRIM(STR(i,5,0))+' WZ (ogem: '+LTRIM(STR(LEN(oaWZW),5,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   c_1   :=D_XML2OemF(oaWZW[i]:findNode('tns:Numer2WZ'))
   c_2   :=D_XML2OemF(oaWZW[i]:findNode('tns:KodTowaruWZ'))
   c_3   :=D_XML2OemF(oaWZW[i]:findNode('tns:NazwaTowaruWZ'))
   c_4   :=D_XML2OemF(oaWZW[i]:findNode('tns:IloscWydanaWZ'))
   c_5   :=D_XML2OemF(oaWZW[i]:findNode('tns:JednostkaMiaryWZ'))
   c_6   :=D_XML2OemF(oaWZW[i]:findNode('tns:CenaJednWZ'))
   c_7   :=D_XML2OemF(oaWZW[i]:findNode('tns:WartoscPozycjiWZ'))

   AAdd(aWZW,{c_1,c_2,c_3,c_4,c_5,c_6,c_7})
 NEXT
 oaWZW:=NIL
 oCtrl:=oaFaktura:findNode('tns:WZCtrl')
 cLiczbaWZ :=D_XML2Oem(oCtrl:findNode('tns:LiczbaWZ'))
 cWartoscWZ:=D_XML2Oem(oCtrl:findNode('tns:SumaWZ'))
 ASort(aWZW,,,{|aX,aY| aX[1]<aY[1]})
 oCtrl:=NIL
ENDIF
oaFaktura:=oJPK:findNode('tns:RW')
IF ValType(oaFaktura)='O'
 oaRW:=oaFaktura:findNode('tns:RWWartosc',.T.)
 FOR i:=1 TO LEN(oaRW)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,1,2,'Wczytuj '+LTRIM(STR(i,5,0))+' RW (ogem: '+LTRIM(STR(LEN(oaRW),5,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   c_1   :=D_XML2OemF(oaRW[i]:findNode('tns:NumerRW'))
   c_2   :=D_XML2OemF(oaRW[i]:findNode('tns:DataRW'))
   c_3   :=D_XML2OemF(oaRW[i]:findNode('tns:WartoscRW'))
   c_4   :=D_XML2OemF(oaRW[i]:findNode('tns:DataWydaniaRW'))
   c_5   :=D_XML2OemF(oaRW[i]:findNode('tns:SkadRW'))
   c_6   :=D_XML2OemF(oaRW[i]:findNode('tns:DokadRW'))
   AAdd(aRW,{STR(i,5,0),c_1,c_2,c_3,c_4,c_5,c_6})
 NEXT
 oaRW:=NIL
 oaRWW:=oaFaktura:findNode('tns:RWWiersz',.T.)
 FOR i:=1 TO LEN(oaRWW)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,1,2,'Wczytuj '+LTRIM(STR(i,5,0))+' RW (ogem: '+LTRIM(STR(LEN(oaRWW),5,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   c_1   :=D_XML2OemF(oaRWW[i]:findNode('tns:Numer2RW'))
   c_2   :=D_XML2OemF(oaRWW[i]:findNode('tns:KodTowaruRW'))
   c_3   :=D_XML2OemF(oaRWW[i]:findNode('tns:NazwaTowaruRW'))
   c_4   :=D_XML2OemF(oaRWW[i]:findNode('tns:IloscWydanaRW'))
   c_5   :=D_XML2OemF(oaRWW[i]:findNode('tns:JednostkaMiaryRW'))
   c_6   :=D_XML2OemF(oaRWW[i]:findNode('tns:CenaJednRW'))
   c_7   :=D_XML2OemF(oaRWW[i]:findNode('tns:WartoscPozycjiRW'))

   AAdd(aRWW,{c_1,c_2,c_3,c_4,c_5,c_6,c_7})
 NEXT
 oaRWW:=NIL
 oCtrl:=oaFaktura:findNode('tns:RWCtrl')
 cLiczbaRW :=D_XML2Oem(oCtrl:findNode('tns:LiczbaRW'))
 cWartoscRW:=D_XML2Oem(oCtrl:findNode('tns:SumaRW'))
 ASort(aRWW,,,{|aX,aY| aX[1]<aY[1]})
 oCtrl:=NIL
ENDIF
oaFaktura:=oJPK:findNode('tns:MM')
IF ValType(oaFaktura)='O'
 oaMM:=oaFaktura:findNode('tns:MMWartosc',.T.)
 FOR i:=1 TO LEN(oaMM)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,1,2,'Wczytuj '+LTRIM(STR(i,5,0))+' MM (ogem: '+LTRIM(STR(LEN(oaMM),5,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   c_1   :=D_XML2OemF(oaMM[i]:findNode('tns:NumerMM'))
   c_2   :=D_XML2OemF(oaMM[i]:findNode('tns:DataMM'))
   c_3   :=D_XML2OemF(oaMM[i]:findNode('tns:WartoscMM'))
   c_4   :=D_XML2OemF(oaMM[i]:findNode('tns:DataWydaniaMM'))
   c_5   :=D_XML2OemF(oaMM[i]:findNode('tns:SkadMM'))
   c_6   :=D_XML2OemF(oaMM[i]:findNode('tns:DokadMM'))
   AAdd(aMM,{STR(i,5,0),c_1,c_2,c_3,c_4,c_5,c_6})
 NEXT
 oaMM:=NIL
 oaMMW:=oaFaktura:findNode('tns:MMWiersz',.T.)
 FOR i:=1 TO LEN(oaMMW)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,1,2,'Wczytuj '+LTRIM(STR(i,5,0))+' MM (ogem: '+LTRIM(STR(LEN(oaMMW),5,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   c_1   :=D_XML2OemF(oaMMW[i]:findNode('tns:Numer2MM'))
   c_2   :=D_XML2OemF(oaMMW[i]:findNode('tns:KodTowaruMM'))
   c_3   :=D_XML2OemF(oaMMW[i]:findNode('tns:NazwaTowaruMM'))
   c_4   :=D_XML2OemF(oaMMW[i]:findNode('tns:IloscWydanaMM'))
   c_5   :=D_XML2OemF(oaMMW[i]:findNode('tns:JednostkaMiaryMM'))
   c_6   :=D_XML2OemF(oaMMW[i]:findNode('tns:CenaJednMM'))
   c_7   :=D_XML2OemF(oaMMW[i]:findNode('tns:WartoscPozycjiMM'))

   AAdd(aMMW,{c_1,c_2,c_3,c_4,c_5,c_6,c_7})
 NEXT
 oaMMW:=NIL
 oCtrl:=oaFaktura:findNode('tns:MMCtrl')
 cLiczbaMM :=D_XML2Oem(oCtrl:findNode('tns:LiczbaMM'))
 cWartoscMM:=D_XML2Oem(oCtrl:findNode('tns:SumaMM'))
 ASort(aMMW,,,{|aX,aY| aX[1]<aY[1]})
 oCtrl:=NIL
ENDIF
oaFaktura:=NIL
oJPK:=NIL

DC_Impl(aScreen)
nFontSize:=VAL(SUBS(cSayFont,1,AT('.',cSayFont)-1))-1
nFontSize:=Min(nFontSize,12)
cBrowseFont:=LTRIM(STR(nFontSize,2,0))+SUBS(cSayFont,AT('.',cSayFont))

@ 0, 0 DCTABPAGE oTabPage1 CAPTION 'Dane podstawowe' SIZE 87,24 TABHEIGHT 36 TABWIDTH 16
DCSETPARENT TO oTabPage1
@ 2, 2 DCSAY 'Jednostka:' SAYSIZE 0
@ 3, 2 DCSAY 'NIP:' SAYSIZE 0
@ 4, 2 DCSAY 'Dane za okres od:' SAYSIZE 0
@ 5, 2 DCSAY 'do:'
@ 6, 2 DCSAY 'Data wytworzenia:' SAYSIZE 0
@ 7, 2 DCSAY 'Godzina wytworzenia:' SAYSIZE 0
@ 9, 2 DCSAY 'magazyn:' SAYSIZE 0
@10, 2 DCSAY 'Liczba PZ:' SAYSIZE 0
@11, 2 DCSAY 'Warto PZ:' SAYSIZE 0
@12, 2 DCSAY 'Liczba WZ:' SAYSIZE 0
@13, 2 DCSAY 'Warto WZ:' SAYSIZE 0
@14, 2 DCSAY 'Liczba RW:' SAYSIZE 0
@15, 2 DCSAY 'Warto RW:' SAYSIZE 0
@16, 2 DCSAY 'Liczba MM:' SAYSIZE 0
@17, 2 DCSAY 'Warto MM:' SAYSIZE 0

@ 2,20 DCGET cPelnaNazwa EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 3,20 DCGET cNIP EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 4,20 DCGET cDataOd EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 5,20 DCGET cDataDo EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 6,20 DCGET cDataWytworzenia EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 7,20 DCGET cGodzWytworzenia EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 9,20 DCGET cMagazyn EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@10,20 DCGET cLiczbaPZ EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@11,20 DCGET cWartoscPZ EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@12,20 DCGET cLiczbaWZ EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@13,20 DCGET cWartoscWZ EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@14,20 DCGET cLiczbaRW EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@15,20 DCGET cWartoscRW EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@16,20 DCGET cLiczbaMM EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@17,20 DCGET cWartoscMM EDITPROTECT {||.T.} GETCOLOR {||SayColor}

DCSETPARENT TO

 @ 0, 0 DCTABPAGE oTabPage2 CAPTION 'PZ' SIZE 87,24 RELATIVE oTabPage1
 DCSETPARENT TO oTabPage2
IF LEN(aPZ)>0
 @ 1.3,20 DCPUSHBUTTON CAPTION 'Szczegy dokument' SIZE 15,1.5 TOOLTIP 'Poka wszystkie pozycje dokumentu' ACTION {||D_PokazJPKMAGSzczegoly(aPZ[nPos1,2],'PZ'),SetAppFocus(oBrowse1)}

 nPos1:=1
 @ 3,1 DCBROWSE oBrowse1 DATA aPZ POINTER nPos1 SIZE 85,21 FIT CURSORMODE XBPBRW_CURSOR_ROW PRESENTATION DC_BrowPres() FONT cBrowseFont
    DCBROWSECOL ELEMENT 1 HEADER 'Lp.' PARENT oBrowse1 WIDTH 4 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 2 HEADER 'Numer PZ' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 3 HEADER 'Data PZ' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_HCENTER
    DCBROWSECOL ELEMENT 4 HEADER 'Warto' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 5 HEADER 'Otrzymano' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_HCENTER
    DCBROWSECOL ELEMENT 6 HEADER 'Dostawca' PARENT oBrowse1 WIDTH 15 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 7 HEADER 'Nr faktury' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 8 HEADER 'Data faktury' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_HCENTER
ENDIF
DCSETPARENT TO

@ 0, 0 DCTABPAGE oTabPage3 CAPTION 'WZ' SIZE 87,24 RELATIVE oTabPage2
 DCSETPARENT TO oTabPage3
IF LEN(aWZ)>0
 @ 1.3,20 DCPUSHBUTTON CAPTION 'Szczegy dokument' SIZE 15,1.5 TOOLTIP 'Poka wszystkie pozycje dokumentu' ACTION {||D_PokazJPKMAGSzczegoly(aWZ[nPos2,2],'WZ'),SetAppFocus(oBrowse2)}

 nPos2:=1
 @ 3,1 DCBROWSE oBrowse2 DATA aWZ POINTER nPos2 SIZE 85,21 FIT CURSORMODE XBPBRW_CURSOR_ROW PRESENTATION DC_BrowPres() FONT cBrowseFont
    DCBROWSECOL ELEMENT 1 HEADER 'Lp.' PARENT oBrowse2 WIDTH 4 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 2 HEADER 'Numer WZ' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 3 HEADER 'Data WZ' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_HCENTER
    DCBROWSECOL ELEMENT 4 HEADER 'Warto' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 5 HEADER 'Wydano' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_HCENTER
    DCBROWSECOL ELEMENT 6 HEADER 'Odbiorca' PARENT oBrowse2 WIDTH 15 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 7 HEADER 'Nr faktury' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 8 HEADER 'Data faktury' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_HCENTER
ENDIF
DCSETPARENT TO

@ 0, 0 DCTABPAGE oTabPage4 CAPTION 'RW' SIZE 87,24 RELATIVE oTabPage3
 DCSETPARENT TO oTabPage4
IF LEN(aRW)>0
 @ 1.3,20 DCPUSHBUTTON CAPTION 'Szczegy dokument' SIZE 15,1.5 TOOLTIP 'Poka wszystkie pozycje dokumentu' ACTION {||D_PokazJPKMAGSzczegoly(aRW[nPos3,2],'RW'),SetAppFocus(oBrowse3)}

 nPos3:=1
 @ 3,1 DCBROWSE oBrowse3 DATA aRW POINTER nPos3 SIZE 85,21 FIT CURSORMODE XBPBRW_CURSOR_ROW PRESENTATION DC_BrowPres() FONT cBrowseFont
    DCBROWSECOL ELEMENT 1 HEADER 'Lp.' PARENT oBrowse3 WIDTH 4 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 2 HEADER 'Numer RW' PARENT oBrowse3 WIDTH 6 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 3 HEADER 'Data RW' PARENT oBrowse3 WIDTH 6 ALIGN XBPALIGN_HCENTER
    DCBROWSECOL ELEMENT 4 HEADER 'Warto' PARENT oBrowse3 WIDTH 6 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 5 HEADER 'Wydano' PARENT oBrowse3 WIDTH 6 ALIGN XBPALIGN_HCENTER
    DCBROWSECOL ELEMENT 6 HEADER 'Skd' PARENT oBrowse3 WIDTH 15 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 7 HEADER 'Dokd' PARENT oBrowse3 WIDTH 15 ALIGN XBPALIGN_LEFT
ENDIF
DCSETPARENT TO

@ 0, 0 DCTABPAGE oTabPage5 CAPTION 'MM' SIZE 87,24 RELATIVE oTabPage4
 DCSETPARENT TO oTabPage5
IF LEN(aMM)>0
 @ 1.3,20 DCPUSHBUTTON CAPTION 'Szczegy dokument' SIZE 15,1.5 TOOLTIP 'Poka wszystkie pozycje dokumentu' ACTION {||D_PokazJPKMAGSzczegoly(aRW[nPos4,2],'MM'),SetAppFocus(oBrowse4)}

 nPos4:=1
 @ 3,1 DCBROWSE oBrowse4 DATA aMM POINTER nPos4 SIZE 85,21 FIT CURSORMODE XBPBRW_CURSOR_ROW PRESENTATION DC_BrowPres() FONT cBrowseFont
    DCBROWSECOL ELEMENT 1 HEADER 'Lp.' PARENT oBrowse4 WIDTH 4 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 2 HEADER 'Numer MM' PARENT oBrowse4 WIDTH 6 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 3 HEADER 'Data MM' PARENT oBrowse4 WIDTH 6 ALIGN XBPALIGN_HCENTER
    DCBROWSECOL ELEMENT 4 HEADER 'Warto' PARENT oBrowse4 WIDTH 6 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 5 HEADER 'Wydano' PARENT oBrowse4 WIDTH 6 ALIGN XBPALIGN_HCENTER
    DCBROWSECOL ELEMENT 6 HEADER 'Skd' PARENT oBrowse4 WIDTH 15 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 7 HEADER 'Dokd' PARENT oBrowse4 WIDTH 15 ALIGN XBPALIGN_LEFT
ENDIF
DCSETPARENT TO

DCGETOPTIONS NOMAXBUTTON NOMINBUTTON
DCREAD GUI MODAL FIT BUTTONS DCGUI_BUTTON_OK OPTIONS GetOptions TITLE 'Zawarto pliku JPK-MAG '+cFile EVAL {|o| SetAppWindow(o)}

aPZW:={}
aWZW:={}
aRWW:={}
aMMW:={}
RETURN(NIL)


FUNCTION D_PokazJPKMAGSzczegoly(cNrFaktury,cTyp)
* Wyswietlenie szczegolow faktury
**********************************
Local GetList:={},GetOptions,aWykaz:={},nPos,oBrowse
DO CASE
CASE cTyp='PZ'
   nPos:=AScan(aPZW,{|a| cNrFaktury==a[1]})
CASE cTyp='WZ'
   nPos:=AScan(aWZW,{|a| cNrFaktury==a[1]})
CASE cTyp='RW'
   nPos:=AScan(aRWW,{|a| cNrFaktury==a[1]})
CASE cTyp='MM'
   nPos:=AScan(aMMW,{|a| cNrFaktury==a[1]})
ENDCASE
IF nPos=0
   DC_MsgBox(,,{'Brak specyfikacji dla dokumentu!'},,,2)
   RETURN(NIL)
ENDIF
DO CASE
CASE cTyp='PZ'
   DO WHILE nPos<=LEN(aPZW)
      IF aPZW[nPos,1]#cNrFaktury
         EXIT
      ENDIF
      AAdd(aWykaz,aPZW[nPos])
      nPos:=nPos+1
   ENDDO
CASE cTyp='WZ'
   DO WHILE nPos<=LEN(aWZW)
      IF aWZW[nPos,1]#cNrFaktury
         EXIT
      ENDIF
      AAdd(aWykaz,aWZW[nPos])
      nPos:=nPos+1
   ENDDO
CASE cTyp='RW'
   DO WHILE nPos<=LEN(aRWW)
      IF aRWW[nPos,1]#cNrFaktury
         EXIT
      ENDIF
      AAdd(aWykaz,aRWW[nPos])
      nPos:=nPos+1
   ENDDO
CASE cTyp='MM'
   DO WHILE nPos<=LEN(aMMW)
      IF aMMW[nPos,1]#cNrFaktury
         EXIT
      ENDIF
      AAdd(aWykaz,aMMW[nPos])
      nPos:=nPos+1
   ENDDO
ENDCASE
FOR i:=1 TO LEN(aWykaz)
   aWykaz[i,1]:=STR(i,4,0)
NEXT
nPos:=1
@3,0 DCBROWSE oBrowse DATA aWykaz POINTER nPos SIZE 88,16 FIT CURSORMODE XBPBRW_CURSOR_ROW PRESENTATION DC_BrowPres() ITEMSELECTED {||aFaktury[nPos,2]:=!aFaktury[nPos,2],nIleZazn:=nIleZazn+IF(aFaktury[nPos,2],1,-1),oBrowse:refreshCurrent(),oBrowse:down(),oBrowse:refreshCurrent(),DC_GetRefresh(GetList)} FONT cBrowseFont
   DCBROWSECOL ELEMENT 1 HEADER 'Lp.' PARENT oBrowse WIDTH 3 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 2 HEADER 'Kod towaru' PARENT oBrowse WIDTH 8 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 3 HEADER 'Nazwa' PARENT oBrowse WIDTH 25 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 4 HEADER 'Ilo' PARENT oBrowse WIDTH 4.5 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 5 HEADER 'JM' PARENT oBrowse WIDTH 4  ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 6 HEADER 'Cena' PARENT oBrowse WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 7 HEADER 'Warto' PARENT oBrowse WIDTH 6 ALIGN XBPALIGN_RIGHT

DCGETOPTIONS NOMAXBUTTON NOMINBUTTON
DCREAD GUI MODAL FIT BUTTONS DCGUI_BUTTON_OK OPTIONS GetOptions TITLE 'Specyfikacja dokumentu '+cTyp+' numer '+cNrFaktury EVAL {|o|SetAppFocus(oBrowse),SetAppWindow(o)}
RETURN(NIL)


FUNCTION D_PokazJPKKR
* Funkcja wczytuje do tablic zawartosc XML z pliku JPK-KR
**********************************************************************
Local oJPKXML,oJPK,oNaglowek,oPodmiot,oPodmiotIdn,oaFaktura
Local aScreen,i,nFontSize,cBrowseFont
Local nPos1,nPos2,nPos3,oBrowse1,oBrowse2,oBrowse3,oTabPage1,oTabPage2,oTabPage3,oTabPage4
Local GetList:={},GetOptions,lOdpow
Local aZOIS:={},aDziennik:={}

PARAMETERS cFile
PRIVATE aKonto:={}

cFile:=ALLTRIM(cFile)

aScreen:=dc_expl(10,1,13,79,,,,,,cSayFont,.T.)
dc_say(aScreen,1,2,'Sprawdzam plik '+cFile+SPACE(10))

IF FSize(ConvToAnsiCP(ALLTRIM(cFile)))>250000000
   DC_Impl(aScreen)
   DC_MsgBox(,,{'Plik zbyt duy, moliwy jest podgld',;
                'plikw mniejszych ni 250 MB.'})
   RETURN(NIL)
ELSEIF FSize(ConvToAnsiCP(ALLTRIM(cFile)))>2000000
   * gdy plik > 2MB to komunikat ze to moze potrwac
   dc_say(aScreen,2,2,'To moe potrwa nawet kilka minut...'+SPACE(10))
ENDIF
oJPKXML:=DC_Xml2ObjectTree(ConvToAnsiCP(cFile))
dc_say(aScreen,2,2,SPACE(10))
IF EMPTY(oJPKXML)
   DC_Impl(aScreen)
   DC_Msgbox(,,{'Ten plik nie ma struktury JPK-KR.'})
   RETURN(NIL)
ENDIF

oJPK:=oJPKXML:findNode('tns:JPK')
oNaglowek:=oJPK:findNode('tns:Naglowek')
cDataWytworzenia:=D_XML2Oem(oNaglowek:findNode('tns:DataWytworzeniaJPK'))
cGodzWytworzenia:=SUBS(SUBS(cDataWytworzenia,12,8)+SPACE(8),1,8)
cDataWytworzenia:=SUBS(cDataWytworzenia,1,10)
cDataOd:=D_XML2Oem(oNaglowek:findNode('tns:DataOd'))
cDataDo:=D_XML2Oem(oNaglowek:findNode('tns:DataDo'))
oNaglowek:=NIL

oPodmiot:=oJPK:findNode('tns:Podmiot1')
oPodmiotIdn:=oPodmiot:findNode('tns:IdentyfikatorPodmiotu')
cNIP:=D_XML2Oem(oPodmiotIdn:findNode('etd:NIP'))
cPelnaNazwa:=SUBS(D_XML2Oem(oPodmiotIdn:findNode('etd:PelnaNazwa'))+SPACE(70),1,70)
oPodmiot:=NIL

oCtrl:=oJPK:findNode('tns:DziennikCtrl')
cLiczbaDziennik :=D_XML2Oem(oCtrl:findNode('tns:LiczbaWierszyDziennika'))
cKwotaDziennik  :=TRANSFORM(VAL(D_XML2Oem(oCtrl:findNode('tns:SumaKwotOperacji'))),"@R 999,999,999,999.99")
oCtrl:=NIL

oCtrl:=oJPK:findNode('tns:KontoZapisCtrl')
cLiczbaKonto :=D_XML2Oem(oCtrl:findNode('tns:LiczbaWierszyKontoZapisj'))
cKwotaWn     :=TRANSFORM(VAL(D_XML2Oem(oCtrl:findNode('tns:SumaWinien'))),"@R 999,999,999,999.99")
cKwotaMa     :=TRANSFORM(VAL(D_XML2Oem(oCtrl:findNode('tns:SumaMa'))),"@R 999,999,999,999.99")
oCtrl:=NIL

oaZ:=oJPK:findNode('tns:ZOiS',.T.)
FOR i:=1 TO LEN(oaZ)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,1,2,'Wczytuj '+LTRIM(STR(i,5,0))+' ZOiS (ogem: '+LTRIM(STR(LEN(oaZ),5,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   c_1   :=D_XML2Oem(oaZ[i]:findNode('tns:KodKonta'))
   c_2   :=D_XML2Oem(oaZ[i]:findNode('tns:OpisKonta'))
   c_3   :=D_XML2Oem(oaZ[i]:findNode('tns:TypKonta'))
   c_4   :=D_XML2Oem(oaZ[i]:findNode('tns:KodZespolu'))
   c_5   :=D_XML2Oem(oaZ[i]:findNode('tns:OpisZespolu'))
   c_6   :=D_XML2Oem(oaZ[i]:findNode('tns:KodKategorii'))
   c_7   :=D_XML2Oem(oaZ[i]:findNode('tns:OpisKategorii'))
   c_8   :=D_XML2Oem(oaZ[i]:findNode('tns:KodPodkategorii'))
   c_9   :=D_XML2Oem(oaZ[i]:findNode('tns:OpisPodkategorii'))
   c_10  :=TRANSFORM(VAL(D_XML2Oem(oaZ[i]:findNode('tns:BilansOtwarciaWinien'))),"@R 999,999,999,999.99")
   c_11  :=TRANSFORM(VAL(D_XML2Oem(oaZ[i]:findNode('tns:BilansOtwarciaMa'))),"@R 999,999,999,999.99")
   c_12  :=TRANSFORM(VAL(D_XML2Oem(oaZ[i]:findNode('tns:ObrotyWinien'))),"@R 999,999,999,999.99")
   c_13  :=TRANSFORM(VAL(D_XML2Oem(oaZ[i]:findNode('tns:ObrotyMa'))),"@R 999,999,999,999.99")
   c_14  :=TRANSFORM(VAL(D_XML2Oem(oaZ[i]:findNode('tns:ObrotyWinienNarast'))),"@R 999,999,999,999.99")
   c_15  :=TRANSFORM(VAL(D_XML2Oem(oaZ[i]:findNode('tns:ObrotyMaNarast'))),"@R 999,999,999,999.99")
   c_16  :=TRANSFORM(VAL(D_XML2Oem(oaZ[i]:findNode('tns:SaldoWinien'))),"@R 999,999,999,999.99")
   c_17  :=TRANSFORM(VAL(D_XML2Oem(oaZ[i]:findNode('tns:SaldoMa'))),"@R 999,999,999,999.99")
   AAdd(aZOIS,{STR(i,5,0),c_1,c_2,c_3,c_4,c_5,c_6,c_7,c_8,c_9,c_10,;
               c_11,c_12,c_13,c_14,c_15,c_16,c_17})
NEXT
oaZ:=NIL
oaZ:=oJPK:findNode('tns:Dziennik',.T.)
FOR i:=1 TO LEN(oaZ)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,1,2,'Wczytuj '+LTRIM(STR(i,5,0))+' Dziennik (ogem: '+LTRIM(STR(LEN(oaZ),5,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   c_1   :=D_XML2Oem(oaZ[i]:findNode('tns:LpZapisuDziennika'))
   c_2   :=D_XML2Oem(oaZ[i]:findNode('tns:NrZapisuDziennika'))
   c_3   :=D_XML2Oem(oaZ[i]:findNode('tns:OpisDziennika'))
   c_4   :=D_XML2Oem(oaZ[i]:findNode('tns:NrDowoduKsiegowego'))
   c_5   :=D_XML2Oem(oaZ[i]:findNode('tns:RodzajDowodu'))
   c_6   :=D_XML2Oem(oaZ[i]:findNode('tns:DataOperacji'))
   c_7   :=D_XML2Oem(oaZ[i]:findNode('tns:DataDowodu'))
   c_8   :=D_XML2Oem(oaZ[i]:findNode('tns:DataKsiegowania'))
   c_9   :=D_XML2Oem(oaZ[i]:findNode('tns:KodOperatora'))
   c_10  :=D_XML2Oem(oaZ[i]:findNode('tns:OpisOperacji'))
   c_11  :=D_XML2Oem(oaZ[i]:findNode('tns:DziennikKwotaOperacji'))
   AAdd(aDziennik,{LTRIM(STR(i,6,0)),ALLTRIM(c_1),c_2,c_3,c_4,c_5,c_6,c_7,c_8,c_9,c_10,c_11})
NEXT
oaZ:=NIL
oaZ:=oJPK:findNode('tns:KontoZapis',.T.)
FOR i:=1 TO LEN(oaZ)
   * zeby za szybko nie migalo wyswietla co 10 zmiane
   IF Mod(i,10)=0
      dc_say(aScreen,1,2,'Wczytuj '+LTRIM(STR(i,5,0))+' Konto (ogem: '+LTRIM(STR(LEN(oaZ),5,0))+') - prosz czeka!'+SPACE(15))
   ENDIF
   c_1   :=D_XML2Oem(oaZ[i]:findNode('tns:LpZapisu'))
   c_2   :=D_XML2Oem(oaZ[i]:findNode('tns:NrZapisu'))
   c_3   :=D_XML2Oem(oaZ[i]:findNode('tns:KodKontaWinien'))
   c_4   :=D_XML2Oem(oaZ[i]:findNode('tns:KwotaWinien'))
   c_5   :=D_XML2Oem(oaZ[i]:findNode('tns:KwotaWinienWaluta'))
   c_6   :=D_XML2Oem(oaZ[i]:findNode('tns:KodWalutyWinien'))
   c_7   :=D_XML2Oem(oaZ[i]:findNode('tns:OpisZapisuWinien'))
   c_8   :=D_XML2Oem(oaZ[i]:findNode('tns:KodKontaMa'))
   c_9   :=D_XML2Oem(oaZ[i]:findNode('tns:KwotaMa'))
   c_10  :=D_XML2Oem(oaZ[i]:findNode('tns:KwotaMaWaluta'))
   c_11  :=D_XML2Oem(oaZ[i]:findNode('tns:KodWalutyWinien'))
   c_12  :=D_XML2Oem(oaZ[i]:findNode('tns:OpisZapisuMa'))
   AAdd(aKonto,{c_1,c_2,IF(c_3='null','',c_3),c_4,c_5,c_6,c_7,IF(c_8='null','',c_8),c_9,c_10,c_11,c_12})
NEXT
oaZ:=NIL
oJPK:=NIL

DC_Impl(aScreen)
nFontSize:=VAL(SUBS(cSayFont,1,AT('.',cSayFont)-1))-1
nFontSize:=Min(nFontSize,12)
cBrowseFont:=LTRIM(STR(nFontSize,2,0))+SUBS(cSayFont,AT('.',cSayFont))

@ 0, 0 DCTABPAGE oTabPage1 CAPTION 'Dane podstawowe' SIZE 87,24 TABHEIGHT 36 TABWIDTH 16
DCSETPARENT TO oTabPage1
@ 2, 2 DCSAY 'Jednostka:' SAYSIZE 0
@ 3, 2 DCSAY 'NIP:' SAYSIZE 0
@ 4, 2 DCSAY 'Dane za okres od:' SAYSIZE 0
@ 5, 2 DCSAY 'do:'
@ 6, 2 DCSAY 'Data wytworzenia:' SAYSIZE 0
@ 7, 2 DCSAY 'Godzina wytworzenia:' SAYSIZE 0
@ 9, 2 DCSAY 'Liczba wierszy dziennikw:' SAYSIZE 0
@10, 2 DCSAY 'Warto wierszy dziennikw:' SAYSIZE 0
@11, 2 DCSAY 'Liczba kont:' SAYSIZE 0
@12, 2 DCSAY 'Suma Wn:' SAYSIZE 0
@13, 2 DCSAY 'Suma Ma:' SAYSIZE 0

@ 2,15 DCGET cPelnaNazwa EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 3,22 DCGET cNIP EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 4,22 DCGET cDataOd EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 5,22 DCGET cDataDo EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 6,22 DCGET cDataWytworzenia EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 7,22 DCGET cGodzWytworzenia EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@ 9,22 DCGET cLiczbaDziennik EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@10,22 DCGET cKwotaDziennik EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@11,22 DCGET cLiczbaKonto EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@12,22 DCGET cKwotaWn EDITPROTECT {||.T.} GETCOLOR {||SayColor}
@13,22 DCGET cKwotaMa EDITPROTECT {||.T.} GETCOLOR {||SayColor}

DCSETPARENT TO

 @ 0, 0 DCTABPAGE oTabPage2 CAPTION 'Obroty i Salda' SIZE 87,24 RELATIVE oTabPage1
 DCSETPARENT TO oTabPage2
 nPos1:=1
 @ 2,1 DCBROWSE oBrowse1 DATA aZOIS POINTER nPos1 SIZE 85,21 CURSORMODE XBPBRW_CURSOR_ROW PRESENTATION DC_BrowPres() HEADLINES 2 FONT cBrowseFont
    DCBROWSECOL ELEMENT 1  HEADER 'Lp.' PARENT oBrowse1 WIDTH 4 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 2  HEADER 'Konto' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 3  HEADER 'Opis konta' PARENT oBrowse1 WIDTH 12 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 4  HEADER 'Typ' PARENT oBrowse1 WIDTH 3 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 5  HEADER 'Zesp' PARENT oBrowse1 WIDTH 4 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 6  HEADER 'Opis zespou' PARENT oBrowse1 WIDTH 12 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 7  HEADER 'Kategoria' PARENT oBrowse1 WIDTH 5 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 8  HEADER 'Opis kategorii' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 9  HEADER 'Podkategoria' PARENT oBrowse1 WIDTH 6 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 10 HEADER 'Opis podkategorii' PARENT oBrowse1 WIDTH 10 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 11 HEADER 'BO Wn' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 12 HEADER 'BO Ma' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 13 HEADER 'Obroty Wn' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 14 HEADER 'Obroty Ma' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 15 HEADER 'Obroty Wn;narastajco' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 16 HEADER 'Obroty Ma;narastajco' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 17 HEADER 'Saldo Wn' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 18 HEADER 'Saldo Ma' PARENT oBrowse1 WIDTH 8 ALIGN XBPALIGN_RIGHT
DCSETPARENT TO

@ 0, 0 DCTABPAGE oTabPage3 CAPTION 'Dzienniki' SIZE 87,24 RELATIVE oTabPage2
 DCSETPARENT TO oTabPage3
 @ 1.3,20 DCPUSHBUTTON CAPTION 'Szczegy dziennika' SIZE 15,1.5 TOOLTIP 'Poka wszystkie pozycje dokumentu' ACTION {||D_PokazJPKKRSzczegoly(aDziennik[nPos2,3]),SetAppFocus(oBrowse3)}

 nPos2:=1
 @ 3,1 DCBROWSE oBrowse2 DATA aDziennik POINTER nPos2 SIZE 85,21 CURSORMODE XBPBRW_CURSOR_ROW PRESENTATION DC_BrowPres() HEADLINES 3 FONT cBrowseFont
    DCBROWSECOL ELEMENT 1  HEADER 'Lp.' PARENT oBrowse2 WIDTH 4 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 3  HEADER 'Nr;dziennika' PARENT oBrowse2 WIDTH 7.5 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 2  HEADER 'Nr kolejny;zapisu;dziennika' PARENT oBrowse2 WIDTH 5 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 4  HEADER 'Opis dziennika' PARENT oBrowse2 WIDTH 12 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 5  HEADER 'Nr dowodu;ksigowego' PARENT oBrowse2 WIDTH 7 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 6  HEADER 'Rodzaj;dowodu' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 7  HEADER 'Data;operacji' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_HCENTER
    DCBROWSECOL ELEMENT 8  HEADER 'Data;dowodu' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_HCENTER
    DCBROWSECOL ELEMENT 9  HEADER 'Data;ksigowania' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_HCENTER
    DCBROWSECOL ELEMENT 10 HEADER 'Kod;operatora' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 11 HEADER 'Opis operacji' PARENT oBrowse2 WIDTH 10 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 12 HEADER 'Kwota;operacji' PARENT oBrowse2 WIDTH 6 ALIGN XBPALIGN_RIGHT
DCSETPARENT TO

@ 0, 0 DCTABPAGE oTabPage4 CAPTION 'Konta' SIZE 87,24 RELATIVE oTabPage3
 DCSETPARENT TO oTabPage4

 nPos3:=1
 @ 2,1 DCBROWSE oBrowse3 DATA aKonto POINTER nPos3 SIZE 85,21 CURSORMODE XBPBRW_CURSOR_ROW PRESENTATION DC_BrowPres() HEADLINES 2 FONT cBrowseFont
    DCBROWSECOL ELEMENT 1  HEADER 'Lp.' PARENT oBrowse3 WIDTH 4 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 2  HEADER 'Nr;dziennika' PARENT oBrowse3 WIDTH 7.5 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 3  HEADER 'Konto Wn' PARENT oBrowse3 WIDTH 10 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 4  HEADER 'Kwota Wn' PARENT oBrowse3 WIDTH 6 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 5  HEADER 'Kwota Wn;(waluta)' PARENT oBrowse3 WIDTH 6 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 6  HEADER 'Kod;waluty' PARENT oBrowse3 WIDTH 4 ALIGN XBPALIGN_HCENTER
    DCBROWSECOL ELEMENT 7  HEADER 'Opis;transakcji (Wn)' PARENT oBrowse3 WIDTH 12 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 8  HEADER 'Konto Ma' PARENT oBrowse3 WIDTH 10 ALIGN XBPALIGN_LEFT
    DCBROWSECOL ELEMENT 9  HEADER 'Kwota Ma' PARENT oBrowse3 WIDTH 6 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 10 HEADER 'Kwota Ma;(waluta)' PARENT oBrowse3 WIDTH 6 ALIGN XBPALIGN_RIGHT
    DCBROWSECOL ELEMENT 11 HEADER 'Kod;waluty' PARENT oBrowse3 WIDTH 4 ALIGN XBPALIGN_HCENTER
    DCBROWSECOL ELEMENT 12 HEADER 'Opis;transakcji (Ma)' PARENT oBrowse3 WIDTH 10 ALIGN XBPALIGN_LEFT
DCSETPARENT TO

DCGETOPTIONS NOMAXBUTTON NOMINBUTTON
DCREAD GUI MODAL FIT BUTTONS DCGUI_BUTTON_OK OPTIONS GetOptions TITLE 'Zawarto pliku JPK-KR '+cFile EVAL {|o| SetAppWindow(o)}

aKonto:={}
RETURN(NIL)


FUNCTION D_PokazJPKKRSzczegoly(cNrFaktury)
* Wyswietlenie szczegolow faktury
**********************************
Local GetList:={},GetOptions,aWykaz:={},nPos,oBrowse

*ASort(aKonto,,,{|aX,aY| aX[3]+aX[1]<aY[3]+aY[1]})
nPos:=AScan(aKonto,{|a| cNrFaktury==a[2]})
IF nPos=0
   DC_MsgBox(,,{'Brak specyfikacji dla dokumentu!'},,,2)
   RETURN(NIL)
ENDIF
DO WHILE nPos<=LEN(aKonto)
   IF aKonto[nPos,2]#cNrFaktury
      EXIT
   ENDIF
   AAdd(aWykaz,aKonto[nPos])
   nPos:=nPos+1
ENDDO
*ASort(aKonto,,,{|aX,aY| aX[1]<aY[1]})
FOR i:=1 TO LEN(aWykaz)
   aWykaz[i,1]:=STR(i,4,0)
NEXT
nPos:=1
@3,0 DCBROWSE oBrowse DATA aWykaz POINTER nPos SIZE 88,16 CURSORMODE XBPBRW_CURSOR_ROW PRESENTATION DC_BrowPres() ITEMSELECTED {||aFaktury[nPos,2]:=!aFaktury[nPos,2],nIleZazn:=nIleZazn+IF(aFaktury[nPos,2],1,-1),oBrowse:refreshCurrent(),oBrowse:down(),oBrowse:refreshCurrent(),DC_GetRefresh(GetList)} HEADLINES 2 FONT cBrowseFont
   DCBROWSECOL ELEMENT 1  HEADER 'Lp.' PARENT oBrowse WIDTH 3 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 3  HEADER 'Konto Wn' PARENT oBrowse WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 4  HEADER 'Kwota Wn' PARENT oBrowse WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 5  HEADER 'Kwota Wn;(waluta)' PARENT oBrowse WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 6  HEADER 'Kod;waluty' PARENT oBrowse WIDTH 4 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 7  HEADER 'Opis;transakcji (Wn)' PARENT oBrowse WIDTH 14 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 8  HEADER 'Konto Ma' PARENT oBrowse WIDTH 10 ALIGN XBPALIGN_LEFT
   DCBROWSECOL ELEMENT 9  HEADER 'Kwota Ma' PARENT oBrowse WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 10 HEADER 'Kwota Ma;(waluta)' PARENT oBrowse WIDTH 6 ALIGN XBPALIGN_RIGHT
   DCBROWSECOL ELEMENT 11 HEADER 'Kod;waluty' PARENT oBrowse WIDTH 4 ALIGN XBPALIGN_HCENTER
   DCBROWSECOL ELEMENT 12 HEADER 'Opis;transakcji (Ma)' PARENT oBrowse WIDTH 10 ALIGN XBPALIGN_LEFT

DCGETOPTIONS NOMAXBUTTON NOMINBUTTON
DCREAD GUI MODAL FIT BUTTONS DCGUI_BUTTON_OK OPTIONS GetOptions TITLE 'Specyfikacja dziennika '+cNrFaktury EVAL {|o|SetAppFocus(oBrowse),SetAppWindow(o)}
RETURN(NIL)

